#include <iostream>
#include <functional>

std::function<double(double)> compose(std::function<double(double)> one,
				      std::function<double(double)> two){
  return  [&one, &two](double x)->double {one(two(x));};
}

int main(){

  std::function<double(double)> f =
    std::bind(std::divides<double>(), std::placeholders::_1, 2.0);


  
  std::cout << compose(f,f)(8) << std::endl;
  
  return 0;
}
